/*************************************************************************
***     Authentication, authorization, accounting + firewalling package
***     (c) 1998-2003 Anton Vinokurov <anton@netams.com>
***		(c) 2003 NeTAMS Development Team
***		All rights reserved. See 'Copying' file included in distribution
***		For latest version and more info, visit this project web page
***		located at http://www.netams.com
***		 					
*************************************************************************/
/* $Id: messages_fifo.c,v 1.3 2003/02/27 17:26:53 anton Exp $ */

#include "netams.h"

//////////////////////////////////////////////////////////////////////////
// Message class

Message::Message(){
	type=MSG_UNKNOWN;
	next=NULL;
	pdata=NULL;
	data.in=data.out=data.from=data.to=0;
	ap=netunit=id=ts=0;
	stat=NULL;
	}

Message::~Message(){
	if (stat) aFree(stat);
	}

//////////////////////////////////////////////////////////////////////////
// FIFO class

FIFO::FIFO(unsigned max){
	root=last=NULL;
	num_items=total_items=0;
	max_items=max;
	lock=(pthread_mutex_t*)aMalloc(sizeof (pthread_mutex_t));
	pthread_mutex_init(lock, NULL);
	}

FIFO::~FIFO(){
	pthread_mutex_destroy(lock);
	}

unsigned FIFO::Push(Message *msg){
	pthread_mutex_lock(lock);
	if (root==NULL) root=msg;
	else last->next=msg;
	last=msg;
	msg->next=NULL; 
	num_items++;
	total_items++;
	pthread_mutex_unlock(lock);
//	printf("FIFO push: %p\n", msg);
	return total_items;
	}

Message* FIFO::Pop(){
	pthread_mutex_lock(lock);
	Message *m;
	m=root;
	if (root) root=root->next;
	num_items--;
	pthread_mutex_unlock(lock);
//	printf("FIFO pop:  %p\n", m);
	return m;
	}
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

