/*************************************************************************
***     Authentication, authorization, accounting + firewalling package
***     (c) 1998-2003 Anton Vinokurov <anton@netams.com>
***		(c) 2003 NeTAMS Development Team
***		All rights reserved. See 'Copying' file included in distribution
***		For latest version and more info, visit this project web page
***		located at http://www.netams.com
***		 					
*************************************************************************/
/* $Id: policy_prefix.h,v 1.7 2003/05/16 14:53:13 jura Exp $ */

#include <sys/mman.h>

extern match MATCH[4];

typedef struct prefix {
	unsigned long	network;
	unsigned mask;
	unsigned long	match;
} prefix;

class PrefixTree;

class PrefixFile {
	public:
		prefix *list;
		PrefixTree *ptree;
		char *filename;
		FILE *descriptor;
		unsigned num_prefixes;
		pthread_rwlock_t *rwlock;
		PrefixFile();
		~PrefixFile();
		int Load(char *filename); // *
		int Unload(); // *
		void Do(Connection *conn, char *action, char *action2=NULL);
		unsigned short Check(unsigned long addr);  // we will check if adr match prefix
		void Dump(Connection *conn);
		void Save(Connection *conn);
		void Sort(Connection *conn);
		};


