/*************************************************************************
***     Authentication, authorization, accounting + firewalling package
***     (c) 1998-2003 Anton Vinokurov <anton@netams.com>
***		(c) 2003 NeTAMS Development Team
***		All rights reserved. See 'Copying' file included in distribution
***		For latest version and more info, visit this project web page
***		located at http://www.netams.com
***		 					
*************************************************************************/
/* $Id: s_login.c,v 1.1 2003/05/19 16:41:16 anton Exp $ */

#include "netams.h"

//////////////////////////////////////////////////////////////////////////////////////////
void sLgInit(Service *s){
	Login_cfg *cfg = (Login_cfg*)aMalloc(sizeof(Login_cfg));
	cfg->default_inact=10*60;	// 10 minutes
	cfg->default_abs=12*60*60;	// 12 hours
	cfg->max_inact=0; 		cfg->min_inact=60;
	cfg->max_abs=0;			cfg->min_abs=60;
	cfg->min_passwd_length=3;
	cfg->delay=10; // LOGIN activity will be checked every 10 seconds

	s->cfg=cfg;
	pthread_create(&(s->t_id), NULL, &sLogin, s);

	}

//////////////////////////////////////////////////////////////////////////////////////////
void sLgProcessCfg(char *param[32], Connection *conn, unsigned no_flag){

	Service *s=NULL;
	if(!(s=Services.getServiceByName("login",s))) return;

	Login_cfg *cfg=(Login_cfg*)s->cfg;

	if (!strcasecmp(param[0], "")) {
		int i=2;
		while (param[i]!=empty) {
	 		if (!strcasecmp(param[i], "")) {
				i++; 
				} 
			}
		}
	}

//////////////////////////////////////////////////////////////////////////////////////////
void sLgListCfg(Service *s, FILE *f){

	if(!(s=Services.getServiceByName("login",s))) return;
	Login_cfg *cfg=(Login_cfg*)s->cfg;

	fprintf(f, "service login %d\n", s->instance);
	fprintf(f, "\n");

	}

//////////////////////////////////////////////////////////////////////////////////////////
void *sLogin(void *ss){
	Service *s=(Service*)ss;
	Login_cfg *cfg=(Login_cfg*)s->cfg;

	aLog(D_INFO, "service login:%u thread started (%p)\n", s->instance, s->cfg);
	pthread_cleanup_push(sLgCancel, s);
	pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
	s->t_id=pthread_self();

	// now we should sleep before starting service
	if (!sMain->isSleep()) s->Sleep();

	aLog(D_DEBUG, "service login:%u checking every %d seconds\n", s->instance,cfg->delay/1000);
	while (1) {

		s->Sleep(cfg->delay); // login timeouts will be checked every cfg->delay seconds
		}

	pthread_cleanup_pop(0);
	return NULL;
	}

//////////////////////////////////////////////////////////////////////////////////////////
void sLgCancel(void *v){
	Service *s = (Service*)v;
	aFree(s->cfg);
	aLog(D_INFO, "cancelling service login:%u\n", s->instance);
    Services.Delete(s);

	}

//////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////

